var App = require('./lib/app');
var Route = require('./lib/route');
var Pages = require('./lib/pages');
var Backend = require('./lib/backend');
var BackendConfig = require('./lib/backend_config');
var BackendWxss = require('./lib/app_admin_wxss');
var Package = require('./lib/package');

var path = require('path');
var fs = require('fs');
var fse = require('fs-extra');
var debug = require('debug')('wevue');


module.exports = {
  wx2vue: function(wxFolder, vueFolder, rootFolder, wevueFolder, program, cb) {

    debug('index wevueFolder', wevueFolder);
    var appJsonFile = path.join(wxFolder, "app.json");
    var app;

    //生成目录 将vue 目录 复制到 wxFolder/.tmp下面

    App(wxFolder, vueFolder, rootFolder, wevueFolder, program);

    //生成package.json
    Package(wxFolder, vueFolder, rootFolder, wevueFolder, program);

    //生成路由
    if (fs.existsSync(appJsonFile)) {
      app = require(path.join(wxFolder, "app.json"));
      Route(vueFolder, app, rootFolder);
      //生成Pages
      Pages(wxFolder, vueFolder, app, rootFolder, wevueFolder, program, function() {
        //增加对backend的转化
        Backend(wxFolder, vueFolder, rootFolder, wevueFolder, program);
        cb(null, null);

      });
    } else {
      var appAdminJsonFile = path.join(wxFolder, "app-admin.json");
      if (fs.existsSync(appAdminJsonFile)) {
        //生成admin.html
        BackendConfig(wxFolder, vueFolder, rootFolder, wevueFolder, program);

        //生成backend.vue
        Backend(wxFolder, vueFolder, rootFolder, wevueFolder, program);

        //app-admin.wxss to app-admin.css
        BackendWxss(wxFolder, vueFolder, rootFolder);

        //生成backend下的pages
        app = require(appAdminJsonFile);
        Pages(wxFolder, vueFolder, app, rootFolder, wevueFolder, program, cb);
      } else {
        cb(null, null);
      }
    }



  }
}
